module UU
  module OS
    module GVC

      module Styleable

        # visual style class
        attr_accessor :style_class

        def style_class
          attributes[:styleClass]
        end

        def style_class=(style_class)
          attributes[:styleClass] = style_class
        end

        # Adds style class into style_class attribute.
        #
        # @param [String] aClass - one or more classes separated by space to add
        def add_style_class(aClass)
          manage_style_class(aClass, false);
        end

        # Removes style class from style_class attribute.
        #
        # @param [String] aClass - one or more classes separated by space to remove
        def remove_style_class(aClass)
          manage_style_class(aClass, true);
        end

        private

        def manage_style_class(aClass, remove)
         inputClasses = {}

         if (!(style_class.nil?) && !(style_class.empty?))
           style_class.split(" ").each do |className|
               inputClasses[className] = true
           end
         end

         aClass.split(" ").each do |className|
           inputClasses[className] = !remove
         end

         result = ""
         inputClasses.each do |key, value|
           if (value)
             result = result + " " + key
           end
         end

         if (!result.nil?)
           attributes[:styleClass] = result.strip
         else
           attributes[:styleClass] = result
         end

        end

      end
    end
  end
end